/**********************************************************************
 *  nbV̊Ǘ
 **********************************************************************
 *
 * nbV\͂Qׂ̂̃Gg[\ō\܂B
 * nbVlZ̍\́Aol.p̃yAłB

 * \̓o^A͕L[ōsAʂ32bitl݂̂łB

 * nbV\̃Gg[͂Qׂ̂łΔCӌŐ܂B
 * ̃nbVlՓ˂ꍇ́AZ̒PXgH܂B
 * \̍폜͏o܂B



//	nbVAo^A ̊e֐.

HASH *hash_create(int entsize);
int   hash_insert(HASH *h,char *str,int val,int dupok);
int	  hash_search(HASH *h,char *str,int *val);


 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "hash.h"

char *xstrdup(char *s);


/**********************************************************************
 *  
 **********************************************************************
 */
static int power_of_2(int nmax)
{
	int i,n;
	n = 1;
	for(i=0;i<29;i++,n<<=1) {
		if(nmax <= n) return n;	// nmax ȏ 2ׂ̂΂Ԃ.
	}
	return 0x4000;	//ftHg.
//	return (-1);	//2^30ȏ ̓_. (e[uQfɂȂ)
}

/**********************************************************************
 *  
 **********************************************************************
 */
void *xmalloc(int size)
{
	void *t = malloc(size);

	if(t==NULL) {
		printf("memory exhaust.\n");
		exit(-1);
	}
	return t;
}

/**********************************************************************
 * 	PXg̍쐬.
 **********************************************************************
 */
CELL *make_cell(char *str,int val,CELL *next)
{
	int size = sizeof(CELL) + strlen(str);
	CELL *hval = malloc(size);

	if(hval==NULL) {
		printf("memory exhaust.\n");
		exit(-1);
	}

	strcpy(hval->str,str);
	hval->val  = val;
	hval->next = next;

	return hval;
}

/**********************************************************************
 *  AhXnbV̏iNAj
 **********************************************************************
 */
HASH *hash_create(int entsize)
{
    int len;
	HASH *h = xmalloc(sizeof(HASH));
	entsize = power_of_2(entsize);
	len = entsize * sizeof(void*);

	h->entry_size  = entsize;
	h->entry_mask  = entsize - 1;
	h->entry_table = xmalloc(len);

	//	Gg[SNA܂.
	memset(h->entry_table,0,len);

	return h;
}

//	̃nbVlvZ܂B
static	int	calc_hash(char *s,int mask)
{
	int val=0;
	while(*s) {
		val *= 9;
		val += *s & 0xff;
		s++;
	}
    return val & mask;
}


/**********************************************************************
 *  F1Ԃ. ݂Ȃꍇ 0.
 **********************************************************************
 */
int	hash_search(HASH *h,char *str,int *val)
{
	int	 index = calc_hash(str,h->entry_mask);	//nbVlGg[index𓾂.
	CELL *hval = h->entry_table[index];	//nbVZ̃|C^𓾂.

    while(hval) {
        if( strcmp(hval->str,str)==0 ) {	//ۂɔr܂.
            *val = hval->val;				//ƈꏏɓo^Ăln܂.
            return 1;					//nbV\̒ɊY񂪔܂.
        }
        hval = hval->next;				//񂪃}b`ȂꍇÃGg[Ɉړ.
    }

	return 0;	// ܂.
}

/**********************************************************************
 *  }Fd 1 Ԃ. VKo^ 0 Ԃ.
 **********************************************************************
 */
int hash_insert(HASH *h,char *str,int val,int dupok)
{
	int	 index = calc_hash(str,h->entry_mask);	//nbVlGg[index𓾂.
	CELL *hval = (CELL *)h->entry_table[index];	//nbVZ̃|C^𓾂.
	//printf("hash_insert %s=%x\n",str,val);
	//
	// łɓL[݂Ă邩ǂׂ.
	//
    while(hval) {
        if( strcmp(hval->str,str)==0 ) {	//ۂɔr܂.
			if(dupok) {
	            hval->val = val;			//l݂̂܂.
			}
			return 1;						//nbV\̒ɊY񂪔܂.
        }
        hval = hval->next;					//񂪃}b`ȂꍇÃGg[Ɉړ.
    }

	hval = (CELL *)h->entry_table[index];	//nbVZ̃|C^ēx擾.

	//
	// PXg̍ŏɑ}.
	//
	h->entry_table[index] = make_cell(str,val,hval);
	return 0;	// VK}܂.
}


/**********************************************************************
 *  :
 **********************************************************************
 */
int	hash_iterate(HASH *h , int (*func)(char *p,int v))
{
	CELL *hval;
	int   count = 0;
	int  i;
	int  m = h->entry_size;

	for(i=0;i<m;i++) {
		hval = h->entry_table[i];	//nbVZ̃|C^𓾂.
	    if(hval) {
			do {
				if(	func ) {
					func(hval->str,hval->val);
				}
				count++;
		        hval = hval->next;		//̃Gg[Ɉړ.
			}while(hval);
        }
    }

	return count;	// o^.
}

/**********************************************************************
 *  
 **********************************************************************
 */
